import {Month} from "@/model/Month";

export class Quarter {
    private $_year: number;
    private $_quarter: number;
    private $_month1: Month
    private $_month2: Month
    private $_month3: Month

    constructor(year: number, quarter: number, month1: Month, month2: Month, month3: Month) {
        this.$_year = year;
        this.$_quarter = quarter;
        this.$_month1 = month1;
        this.$_month2 = month2;
        this.$_month3 = month3;
    }

    get month1(): Month {
        return this.$_month1;
    }

    get month2(): Month {
        return this.$_month2;
    }

    get month3(): Month {
        return this.$_month3;
    }

    get year(): number {
        return this.$_year;
    }

    get quarter(): number {
        return this.$_quarter;
    }

    get quarterName(): string {
        return 'Q'+this.$_quarter.toString() + ' ' + this.$_year
    }

    getNumberOfActiveAids(): number {
        return Math.max(this.$_month1.getNumberOfAids(), this.$_month3.getNumberOfAids(), this.$_month3.getNumberOfAids())
    }

    getNumberOfHomehelpHours(): number {
        let totalHours = this.$_month1.getAverageHoursOfHomehelp() + this.$_month2.getAverageHoursOfHomehelp() +this.$_month3.getAverageHoursOfHomehelp()
        return totalHours/3
    }

    getAverageHoursOfHomehelp(): number {
        return this.$_month1.getAverageHoursOfHomehelp() + this.$_month2.getAverageHoursOfHomehelp() + this.$_month3.getAverageHoursOfHomehelp()
    }
}
